#         Script : serials v1.03 by David Proper (Dr. Nibble [DrN])
#                  Copyright 2000-2004 Radical Computer Systems
#
# Original Platform : Linux 2.0.36
#                     Eggdrop v1.2.0+bel1
#       Testing
#      Platforms : Linux 2.4.18   TCL v8.3.4
#                  Eggdrop v1.5.4
#                  Eggdrop v1.6.12
#            And : SunOS 5.8      TCL v8.3
#                  Eggdrop v1.5.4
#
#    Description : Serials is another lame little tcl. All it does is
#                  provide a search function on a flat text file.
#                  Defualt setup is for a list of serial codes.
#                  Search term highlighting, max result change, word
#                  exclusions, etc.
#
# Originally written 2 years ago. Never thought it was really worth
# releasing. But what the hell.
#        History : 03/29/2002 - First Release
#                  04/07/2002 - v1.01
#                              o Holly shit I'm stupid! I deleted the line
#                                that calls the damn search proc! So the
#                                scripts would just sit there! DUHDUHDUHDUH!
#                                "I would like to accept this Idiot Of The
#                                 Year award for all morons like myself..."
#                              o Added in easy way of searching multiple 
#                                files. (In case you seperate by group/alpha
#                                        or whatever..)
#                  07/13/2003 - v1.02
#                              o Added optional line number display
#                              o Added total lines display at end search
#                  03/03/2004 - v1.03
#                              o Now includes a better serial list
#                                (I didn't include a better one initially
#                                 since I didn't intend for this to be a
#                                 'Serial Channel In A Box' kinda thing.
#                              o Added a check to see if the database file
#                                exists.
#                              o Checks to see if cmdchar_ is allready defined
#                              o Added search term highlighting
#                              o Correctlly returns only maxsearch results
#                              o Changed a few variable names
#                              o Changed search method.
#                              o Added ability to exclude words during 
#                                search
#                              o Added DCC command .serial
#                              o Added switch to return fewer results
#                              o Added message command for users to submit
#                                data
#                              o Able to reject requests if queue list
#                                becomes to long.
#
#
#   Future Plans : o None at the moment.
#
#      Donations : https://www.paypal.com/xclick/business=rainbows%40chaotix.net
# (If you don't have PayPal and want to donate, EMail me for an address.
#  Will take money or hardware/computer donations)
#  Significant (or even non-significant donations) can be published on a
#  web site if you so choose.
#
# Author Contact :     Email - DProper@chaotix.net
#           RCS Support Site - http://rcs.chaotix.net
#          Personal Homepage - http://www.chaotix.net/~dproper
#                        IRC - Primary Nick: DrN
#                     UseNet - alt.irc.bots.eggdrop
# Support Channels: #RCS @UnderNet.Org
#                   #RCS @DALnet
#                   #RCS @GalaxyNet
#                   #RCS @Choatix Addiction
#            Other channels - Check contact page for current list
#
#                Current contact information can be located at:
#                 http://rcs.chaotix.net/contact.html
#
# New TCL releases are sent to the following sites as soon as they're released:
#
# FTP Site                   | Directory                     
# ---------------------------+-------------------------------
# ftp.chaotix.net            | /pub/RCS
# ftp.eggheads.org           | Various
# ftp.egghelp.org            | Various
#
# To subscribe to the RCS mailing list:
#  http://www.chaotix.net/mailman/listinfo/rcs-list
#
#  Feel free to Email me any suggestions/bug reports/etc.
#
# You are free to use this TCL/script as long as:
#  1) You don't remove or change author credit
#  2) You don't release it in modified form. (Only the original)
#
# If you have a "too cool" modification, send it to me and it'll be
# included in the official. (With your credit)
#
# Commands Added:
#  Where     F CMD       F CMD         F CMD        F CMD
#  -------   - --------- - ----------- - ---------- - --------- - -------
#  Public:   - !serial   - @find       - !serials   - !search   - @search
#            - !list
#     MSG:   - serial    - addserial
#     DCC:   - serial
#
#
# Big thanks to LtGen of #tcl (UnderNet) for answering a question I had

set serials(ver) "v1.03.01"
if {![info exists cmdchar_]} {set cmdchar_ "!"}

# Set this to the maximum number of results to return
# This number can't be exceeded with the --l search switch.
set serials(maxsearch) 20

# Set this to the default number of results to return
set serials(defaultmaxsearch) 5

# Note sent out when telling them how to search database
set serials(contrib) "To contribute to the list, send any serials to serials@chaotix.net"

# [0/1] Set this to 1 to show the line number in the output
set serials(showlinenumber) 1

# [0/1] Set this to a 1 to highlight the first match in the line
set serials(highlight) 1

# Ignore any lookup requests when the queue list exceeds this number
# Set this to 0 to disable it.
set serials(maxqueue) 200

# Note for Windrop users: It may not like files that start with a .
#  It also has no idea what a ~ means. So use the full
#  drive:path/filename.ext of the file

# Format of the serial list is (flat unix text file, one entry per line):
# path/filename Description
# You can include multiple files to search for.
set serialdata {
 {~/serials.dat General Serial Database}
               }

# Set this to the path/filename.ext of the file you wish to store data
# submitted to the script by the users. You can point this to the main
# serial datafile, but just in case they submit crap/flood it, it'd be
# easier to store them in a seperate file so you can verify them.
# If you want, you can add the file to the end of the serialdata list
# and describe it as "User Submitted Data" etc.
set serials(useraddedfile) "~/userserials.txt"

proc cmdchar { } {
 global cmdchar_
 return $cmdchar_
}

bind pub - !serials pub_serialinform
bind pub - @find pub_serialinform
bind pub - @search pub_serialinform
bind pub - !search pub_serialinform
bind pub - !list pub_serialinform

proc pub_serialinform {nick uhost handle chan args} {
  global serials
    serials_out $nick "To search the serial database: [cmdchar]serial keyword"
    serials_out $nick "$serials(contrib)"
  return 1
}

bind dcc - serial dcc_serialsearch
proc dcc_serialsearch {hand idx args} {
  if {[lindex $args 0] != ""} {
      set a [lindex $args 0]
      doserialsearch $idx $a
  } else {
    putidx $idx "Syntax: .serial <search string>"
         }
  return 1
}


bind pub - [cmdchar]serial pub_serialsearch
proc pub_serialsearch {nick uhost handle chan args} {
  global serials

  if {($serials(maxqueue) > 0) && ([queuesize help]>$serials(maxqueue)]} {
   putserv "NOTICE $nick :Sorry, our queue is near full. Please wait a few minutes and make your request again."
   return 0
     }
  if {[lindex $args 0] != ""} {

  set a [lindex $args 0]
  doserialsearch $nick $a
  } else {
    puthelp "NOTICE $nick :Syntax: [cmdchar]serial <search string>"
  }
  return 1
}


proc msg_serialsearch {nick uhost handle args} {
  global serials
  if {($serials(maxqueue) > 0) && ([queuesize help]>$serials(maxqueue)]} {
   putserv "NOTICE $nick :Sorry, our queue is near full. Please wait a few minutes and make your request again."
   return 0
     }
  if {[lindex $args 0] != ""} {
  set a [lindex $args 0]
  doserialsearch $nick $a
  } else {
    puthelp "NOTICE $nick :Syntax: /msg $botnick serial <search string>"
  }
  return 1
}

bind msg - serial msg_serialsearch

proc doserialsearch {nick data} {
global serials serialdata botnick
serials_out $nick "Serial Search $serials(ver) by DrN"
set maxsearch $serials(defaultmaxsearch)

set wpos [lsearch [string tolower $data] "--l"]
if {$wpos >-1} {
 if {[isnum [lindex $data [expr $wpos +1]]]} {
  set data "[lrange $data 0 [expr $wpos -1]] [lrange $data [expr $wpos + 1] end]"
  set newmaxsearch [lindex $data $wpos]
  set data "[lrange $data 0 [expr $wpos -1]] [lrange $data [expr $wpos + 1] end]"
  while {[string index $data [expr [string length $data]-1]]==" "} {
   set data [string range $data 0 [expr [string length $data] - 2]]}
  if {$newmaxsearch > $serials(maxsearch)} {serials_out $nick "You can not exceed $serials(maxsearch) search results."
                                            return 0
                                           } else {set maxsearch $newmaxsearch}
                                     }
               }
    if {$serials(maxsearch) != 0} {serials_out $nick "There is a limit of $maxsearch results in effect."}
    serials_out $nick "You can exclude words with a - EX: adobe -capture"
    serials_out $nick "You can tell the script to return fewer results with --l num  EX: --l 5"
    serials_out $nick "To submit an entry: /msg $botnick addserial Program Name : Registration Data"
    serials_out $nick "Searching for \"$data\""
    set data [string tolower $data]

foreach sdb $serialdata {
 set sdbf [lindex $sdb 0]
 set sdbd [lrange $sdb 1 end]

 if {![file exists $sdbf]} {
  putlog "\[SERIALS\] ERROR: Can't find $sdbf"
  serials_out $nick "Can't find Database file for $sdbd"
                           } else {
              serials_out $nick "Searching $sdbd"
              searchserials $nick $maxsearch $sdbf $data
                            }
                        }


}

proc searchserials {nick maxsearch database data} {
 global serials
    set in [open $database r]
    set totfound 0
    set linenum 0

    while {![eof $in]} {
      set line [gets $in]
      incr linenum 1
      set found 0
set _line [string tolower $line]
set tplus 0
for {set l 0} {$l < [llength $data]} {incr l} {
 set w [lindex $data $l]
 if {[string index $w 0]=="-"} {
     set w [string range $w 1 end]
     if {[string match "*$w*" $_line]} {set found [expr $found - 1]}
                               } else {
        if {[string match "*$w*" $_line]} {incr found}
        incr tplus
                                      }
                                              }
 if {$tplus == $found} {
if {$serials(highlight)} {
    for {set l 0} {$l < [llength $data]} {incr l} {
     set w [lindex $data $l]
      if {[string index $w 0]!="-"} {
     set spos [string first $w [string tolower $line] 0]
     set fpos [expr $spos + [string length $w]]
     set line "[string range $line 0 [expr $spos - 1]]\002[string range $line $spos $fpos]\002[string range $line [expr $fpos + 1] end]"
                                     }
                                                  }
                          }
       if {$serials(showlinenumber) == 1} {serials_out $nick "($linenum) $line"
           } else {
                   serials_out $nick "$line"
                  }

      if {$totfound >= $maxsearch-1} {
                  serials_out $nick "There are over $maxsearch matches. Please norrow your search."
                  close $in
                  return 0
                                   }
        set totfound [expr $totfound + 1]
     }
    }
    close $in
    serials_out $nick "There was a total of $totfound out of $linenum entries matching your query."

}

bind msg - addserial msg_addserial
proc msg_addserial {nick uhost hand rest} {
global serials
 if {$rest == ""} {serials_out $nick "Calling Syntax: addserial Program name : Registration Data"
                   return 0}
 set out [open $serials(useraddedfile) "a+"]
 puts $out "[ctime [unixtime]] -$nick- $rest"
 close $out
 serials_out $nick "Entry submitted: $rest"
}
 if {![file exists $serials(useraddedfile)]} {
     set out [open $serials(useraddedfile) "w"]
     puts $out "Serials.tcl file. Started on [ctime [unixtime]]"
     puts $out "-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-"
     close $out
                                          }



proc serials_out {nick text} {
if {[isnum $nick]} {putidx $nick $text} else {puthelp "NOTICE $nick :$text"}
}

# isnumber taken from alltools.tcl
proc isnum {string} {
  if {([string compare $string ""]) && (![regexp \[^0-9\] $string])} then {
    return 1
  }
  return 0
}

putlog "Serials $serials(ver) by David Proper (DrN) -: LoadeD :-"
return "Serials $serials(ver) by David Proper (DrN) -: LoadeD :-"

